#include "stdafx.h"
#include "NeMessenger.h"
#include "StickerDlg.h"

#define ID_STICKER_LIST			5000

IMPLEMENT_DYNAMIC(CStickerDlg, CDialog)

CStickerDlg::CStickerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStickerDlg::IDD, pParent)
{
	m_imgTopBg = NULL;
	m_vecStickerGroup.clear();
	m_pParentChatWnd = pParent;
}

CStickerDlg::~CStickerDlg()
{
	m_penBorder.DeleteObject();
	SAFE_DELETE(m_imgTopBg);
	ClearStickerGroupData();
}

void CStickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_PREVIOUS, m_btnPrevious);
	DDX_Control(pDX, IDC_BUTTON_NEXT, m_btnNext);
}


BEGIN_MESSAGE_MAP(CStickerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_KILLFOCUS()
	ON_WM_ACTIVATE()
END_MESSAGE_MAP()


BOOL CStickerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);
	SetWindowText(LoadStringFromResource(IDS_STRING377));	// ƼĿ

	m_penBorder.CreatePen(PS_SOLID, 1, RGB(220,220,220));
	m_imgTopBg = new Image(GetAppImgFile(_T("frame_B_bg.png")));

	m_btnPrevious.SetBtnBitmapFile(GetAppImgFile(_T("Sticker_btn_left.bmp")), RGB(0,0,0));
	m_btnNext.SetBtnBitmapFile(GetAppImgFile(_T("Sticker_btn_right.bmp")), RGB(0,0,0));

	InitControl();
	SetSkin();

	//  â 
	SetStickerWindowPos();
	ReSizeCtrl();
	RedrawWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CStickerDlg::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("StickerDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CStickerDlg::ReSizeCtrl()
{
	CRect rcClient;
	GetClientRect(&rcClient);

	if (m_stickerWnd.GetSafeHwnd())
	{
		m_stickerWnd.MoveWindow(0, rcClient.top + 35, rcClient.Width(), rcClient.Height() - 36);
	}

	if (m_btnPrevious.GetSafeHwnd() && m_btnNext.GetSafeHwnd())
	{
		CRect rtBtn;
		rtBtn.left = 0;
		rtBtn.right = rtBtn.left + m_btnPrevious.GetImgWidth();
		rtBtn.top = 3;
		rtBtn.bottom = rtBtn.top + m_btnPrevious.GetImgHeight();
		m_btnPrevious.MoveWindow(rtBtn, TRUE);

		rtBtn.MoveToX(rcClient.right - m_btnPrevious.GetImgWidth());
		m_btnNext.MoveWindow(rtBtn, TRUE);

		int nLastIndex = m_vecStickerGroup.size() - 1;
		if (nLastIndex >= 0)
		{
			CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[nLastIndex];

			if (pItem)
			{
				if (pItem->m_rtItem.right > rtBtn.left)
				{
					m_btnPrevious.EnableWindow(TRUE);
					m_btnNext.EnableWindow(TRUE);
				}
				else
				{
					m_btnPrevious.EnableWindow(FALSE);
					m_btnNext.EnableWindow(FALSE);
				}
			}
		}
	}
}

void CStickerDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;
	//Trace(_T("---(%d, %d, %d, %d)\n"), ps.rcPaint.left, ps.rcPaint.top, ps.rcPaint.right, ps.rcPaint.bottom);

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt;
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetPageUnit(UnitPixel);
		graph.SetPixelOffsetMode(PixelOffsetModeHalf);

		ImageAttributes ImgAttr;

		graph.DrawLine(&Pen(Color(255,200,200,200), 1), 0, nWndHeight, psWidth, nWndHeight);

		if (m_imgTopBg)
		{
			CRect rtTopBg(0, 0, nWndWidth, m_imgTopBg->GetHeight());
			DrawImageToStretchHorz(&graph, m_imgTopBg, &rtPS, &rtTopBg, Color(32, 255, 255, 255), &ImgAttr);
		}

		graph.SetInterpolationMode(InterpolationModeHighQuality);

		for (DWORD i = 0; i < m_vecStickerGroup.size(); i++)
		{
			CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[i];

			if (!pItem || !pItem->m_img)
				continue;

			//  ̹ 4 η پֱ     ¿ ´ ̹ ũ⸦ ؼ ׸.
			CRect rtSrc;
			rtSrc.left = (pItem->m_img->GetWidth() / 4) * (int)pItem->m_eTabStatus;
			rtSrc.right = rtSrc.left + pItem->m_img->GetWidth() / 4;
			rtSrc.top = 0;
			rtSrc.bottom = rtSrc.top + pItem->m_img->GetHeight();

			DrawImageToDest(&graph, pItem->m_img, &rtPS, &(pItem->m_rtItem), &rtSrc, &ImgAttr);
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CStickerDlg::InitControl()
{
	// ƼĿ  â 
	if (!m_stickerWnd.Create(NULL, _T("Ntalk_Sticker_List"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_VSCROLL, CRect(0, 0, 0, 0), this, ID_STICKER_LIST))
		return;

	m_stickerWnd.SetParentChatWnd(m_pParentChatWnd);

	GET_CONFIG()->LoadStickerGroupInfo(&m_vecStickerGroup);

	int nSX = 32;
	CString strFirstGroupID = _T("");

	for (DWORD i = 0; i < m_vecStickerGroup.size(); i++)
	{
		CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[i];

		if (!pItem)
			continue;

		pItem->m_img = new Image(pItem->m_strImgPath);
		pItem->m_rtItem.left = nSX;
		pItem->m_rtItem.right = pItem->m_rtItem.left + (pItem->m_img->GetWidth() / 4);
		pItem->m_rtItem.top = 3;
		pItem->m_rtItem.bottom = pItem->m_rtItem.top + pItem->m_img->GetHeight();

		nSX += (pItem->m_img->GetWidth() / 4) + 5;

		if (i == 0)
		{
			strFirstGroupID = pItem->m_strGroupID;
			pItem->m_eTabStatus = tabSelect;
		}
	}

	m_stickerWnd.ShowSticker(strFirstGroupID);
}

void CStickerDlg::ClearStickerGroupData()
{
	for (DWORD i = 0; i < m_vecStickerGroup.size(); i++)
	{
		CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[i];
		
		if (!pItem)
			continue;

		SAFE_DELETE(pItem->m_img);
		SAFE_DELETE(pItem);
	}
	m_vecStickerGroup.clear();
}

void CStickerDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	CheckPointInTabBtn(point);

	CDialog::OnMouseMove(nFlags, point);
}

void CStickerDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	TabSelected(point);

	CDialog::OnLButtonDown(nFlags, point);
}

void CStickerDlg::CheckPointInTabBtn(CPoint point)
{
	bool bRedraw = false;

	for (DWORD i = 0; i < m_vecStickerGroup.size(); i++)
	{
		CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[i];

		if (!pItem)
			continue;

		if (pItem->m_rtItem.PtInRect(point))
		{
			if (pItem->m_eTabStatus != tabSelect && pItem->m_eTabStatus != tabOver)
			{
				pItem->m_eTabStatus = tabOver;
				bRedraw = true;
			}
		}
		else
		{
			if (pItem->m_eTabStatus != tabSelect && pItem->m_eTabStatus != tabNormal)
			{
				pItem->m_eTabStatus = tabNormal;
				bRedraw = true;
			}
		}
	}

	if (bRedraw)
		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CStickerDlg::TabSelected(CPoint point)
{
	int nSelectedItem = GetTabItemOnPoint(point);

	if (nSelectedItem == -1)
		return;

	for (DWORD i = 0; i < m_vecStickerGroup.size(); i++)
	{
		CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[i];

		if (!pItem)
			continue;

		if (i == nSelectedItem)
		{
			if (pItem->m_eTabStatus == tabSelect)	//  ð ϴ.
				return;
			else
			{
				pItem->m_eTabStatus = tabSelect;
				m_stickerWnd.ShowSticker(pItem->m_strGroupID);
			}
		}
		else
		{
			pItem->m_eTabStatus = tabNormal;
		}
	}

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

int CStickerDlg::GetTabItemOnPoint(CPoint point)
{
	int nIndex = -1;

	for (DWORD i = 0; i < m_vecStickerGroup.size(); i++)
	{
		CStickerGroupItem* pItem = (CStickerGroupItem*)m_vecStickerGroup[i];

		if (!pItem)
			continue;

		if (pItem->m_rtItem.PtInRect(point))
			return i;
	}

	return nIndex;
}

void CStickerDlg::OnKillFocus(CWnd* pNewWnd)
{
	CDialog::OnKillFocus(pNewWnd);

	m_pParentChatWnd->PostMessage(WM_CHAT_STICKER_DLG_CLOSED, 0, 0);
}

void CStickerDlg::SetStickerData( std::vector<CStickerItem*>* pStickerVector )
{
	m_stickerWnd.AllocStickerDataPointer(pStickerVector);
}

BOOL CStickerDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			m_pParentChatWnd->PostMessage(WM_CHAT_STICKER_DLG_CLOSED, 0, 0);
			return TRUE;
		}
	}
	else if (IsCloseMsg(pMsg))
	{
		m_pParentChatWnd->PostMessage(WM_CHAT_STICKER_DLG_CLOSED, 0, 0);
		return TRUE;
	}

	return CDialog::PreTranslateMessage(pMsg);
}

bool CStickerDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;

	if (pMsg->hwnd != this->GetSafeHwnd())
		return false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// ŸƲ Ŭ޴ > ݱ
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CStickerDlg::SetStickerWindowPos()
{
	// â ġ  ȭâ  ġ ؾ Ѵ.
	const UINT uDlgWidth = 340;
	const UINT uDlgHeight = 330;	// ƼĿ â ũ   ʾ ӽ÷ Y  ÷ ũ  ʰ Ͽ.

	CRect rtParent;
	m_pParentChatWnd->GetWindowRect(&rtParent);

	BOOL bZoomed = m_pParentChatWnd->IsZoomed();
	int nPrimaryWidth = GetSystemMetrics(SM_CXSCREEN);
	int nPrimaryHeight = GetSystemMetrics(SM_CYSCREEN);

	// äâ ʿ  ִ  ʿ ̰,    ʿ δ
	int nSX = 0;
	int nSY = rtParent.bottom - uDlgHeight;

	if (bZoomed)
	{
		nSX = rtParent.left + 66;
		nSY = rtParent.bottom - uDlgHeight - DEF_CHAT_SEND_HEIGHT - 6;
	}
	else if (rtParent.left >= uDlgWidth)	
		nSX = rtParent.left - uDlgWidth;
	else
		nSX = rtParent.right;

	MoveWindow(nSX, nSY, uDlgWidth, uDlgHeight);
}

void CStickerDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);

	if (nState == WA_INACTIVE)
		m_pParentChatWnd->PostMessage(WM_CHAT_STICKER_DLG_CLOSED, 0, 0);
}
